#
# spec file for package libqt5-qt3d
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define qt5_snapshot 0

%define libname libQt53DCore5

Name:           libqt5-qt3d
Version:        5.6.2
Release:        1.3
Summary:        Qt 5 3D Addon
License:        SUSE-LGPL-2.1-with-digia-exception-1.1 or GPL-3.0
Group:          Development/Libraries/X11
Url:            http://qt.digia.com
%define base_name libqt5
%define real_version 5.6.2
%define so_version 5.6.2
%define tar_version qt3d-opensource-src-%{real_version}
Source:         %{tar_version}.tar.xz
Source1:        baselibs.conf
Patch0:         fix-assimp-bigendian-lvalue.diff
BuildRequires:  fdupes
BuildRequires:  libQt5Bootstrap-devel-static >= %{version}
BuildRequires:  libQt5Concurrent-devel >= %{version}
BuildRequires:  libQt5Core-private-headers-devel >= %{version}
BuildRequires:  libQt5Gui-private-headers-devel >= %{version}
BuildRequires:  libQt5OpenGLExtensions-devel-static >= %{version}
BuildRequires:  libqt5-qtdeclarative-private-headers-devel >= %{version}
BuildRequires:  pkgconfig(zlib)

%if %qt5_snapshot
#to create the forwarding headers
BuildRequires:  perl
%endif
BuildRequires:  xz
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%prep
%setup -q -n qt3d-opensource-src-%{real_version}
%ifarch s390 s390x
%patch0 -p1
%endif

%package -n %libname
Summary:        Qt 5 3D Addon
Group:          Development/Libraries/X11
%requires_ge libQt5Core5
# Removed in Qt3D 5.6
Provides:       libQt53dCollision5 = %{version}
Obsoletes:      libQt53dCollision5 < %{version}

%description -n %libname
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package -n libQt53DInput5
Summary:        Qt 5 3D Addon
Group:          Development/Libraries/X11
%requires_ge libQt5Core5

%description -n libQt53DInput5
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package -n libQt53DQuick5
Summary:        Qt 5 3D Addon
Group:          Development/Libraries/X11
%requires_ge libQt5Core5

%description -n libQt53DQuick5
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package -n libQt53DQuickRender5
Summary:        Qt 5 3D Addon
Group:          Development/Libraries/X11
Provides:       libQt53DQuickRenderer5 = %{version}
Obsoletes:      libQt53DQuickRenderer5 < %{version}
%requires_ge libQt5Core5

%description -n libQt53DQuickRender5
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package -n libQt53DRender5
Summary:        Qt 5 3D Addon
Group:          Development/Libraries/X11
Provides:       libQt53DRenderer5 = %{version}
Obsoletes:      libQt53DRenderer5 < %{version}
%requires_ge libQt5Core5

%description -n libQt53DRender5
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package -n libQt53DQuickInput5
Summary:        Qt 5 3D Addon
Group:          Development/Libraries/X11
%requires_ge libQt5Core5

%description -n libQt53DQuickInput5
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package -n libQt53DLogic5
Summary:        Qt 5 3D Addon
Group:          Development/Libraries/X11
%requires_ge libQt5Core5

%description -n libQt53DLogic5
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package imports
Summary:        Qt 5 3D Library - QML imports
Group:          Development/Libraries/X11
Supplements:    packageand(%{libname}:libQtQuick5)
%requires_ge libQtQuick5

%description imports
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package examples
Summary:        Qt5 3D examples
Group:          Development/Libraries/X11
Recommends:     %{name}-devel

%description examples
Examples for libqt5-qt3d module.

%package tools
Summary:        Qt5 3D tools
Group:          Development/Libraries/X11
Recommends:     %{name}-devel

%description tools
Tools for libqt5-qt3d module.

%package -n libQt53DCore-devel
Summary:        Qt 5 Core 3D Library - development files
Group:          Development/Libraries/X11
Requires:       libQt53DCore5 = %{version}

%description -n libQt53DCore-devel
The Qt 5 Core 3D library - development files.

%package -n libQt53DInput-devel
Summary:        Qt 5 Input 3D Library - development files
Group:          Development/Libraries/X11
Requires:       libQt53DInput5 = %{version}

%description -n libQt53DInput-devel
The Qt 5 Input 3D library - development files.

%package -n libQt53DQuick-devel
Summary:        Qt 5 Quick 3D Library - development files
Group:          Development/Libraries/X11
Requires:       libQt53DQuick5 = %{version}

%description -n libQt53DQuick-devel
The Qt 5 Quick 3D library - development files.

%package -n libQt53DQuickRender-devel
Summary:        Qt 5 QuickRenderer 3D Library - development files
Group:          Development/Libraries/X11
Requires:       libQt53DQuickRender5 = %{version}
Provides:       libQt53DQuickRenderer-devel = %{version}
Obsoletes:      libQt53DQuickRenderer-devel < %{version}

%description -n libQt53DQuickRender-devel
The Qt 5 QuickRenderer 3D library - development files.

%package -n libQt53DRender-devel
Summary:        Qt 5 Renderer 3D Library - development files
Group:          Development/Libraries/X11
Requires:       libQt53DRender5 = %{version}
Provides:       libQt53DRenderer-devel = %{version}
Obsoletes:      libQt53DRenderer-devel < %{version}

%description -n libQt53DRender-devel
The Qt 5 Renderer 3D library - development files.

%package -n libQt53DQuickInput-devel
Summary:        Qt 5 QuickInput 3D Library - development files
Group:          Development/Libraries/X11
Requires:       libQt53DQuickInput5 = %{version}

%description -n libQt53DQuickInput-devel
The Qt 5 Quick Input 3D library - development files.

%package -n libQt53DLogic-devel
Summary:        Qt 5 Logic 3D Library - development files
Group:          Development/Libraries/X11
Requires:       libQt53DLogic5 = %{version}

%description -n libQt53DLogic-devel
The Qt 5 Logic 3D library - development files.

%package devel
Summary:        Qt Development Kit
Group:          Development/Libraries/X11
Requires:       libQt53DCore-devel = %{version}
Requires:       libQt53DInput-devel = %{version}
Requires:       libQt53DLogic-devel = %{version}
Requires:       libQt53DQuick-devel = %{version}
Requires:       libQt53DQuickInput-devel = %{version}
Requires:       libQt53DQuickRender-devel = %{version}
Requires:       libQt53DRender-devel = %{version}
# Removed in Qt3D 5.6
Provides:       libQt53dCollision-devel = %{version}
Obsoletes:      libQt53dCollision-devel < %{version}

%description devel
You need this package, if you want to compile programs with qt3d.

%package private-headers-devel
Summary:        Non-ABI stable experimental API
Group:          Development/Libraries/C and C++
BuildArch:      noarch
Requires:       %{name}-devel = %{version}
Requires:       libQt5Core-private-headers-devel >= %{version}
Requires:       libQt5Core-private-headers-devel >= %{version}
Requires:       libQt5Gui-private-headers-devel >= %{version}
Requires:       libQt5OpenGLExtensions-devel-static >= %{version}
Requires:       libqt5-qtdeclarative-private-headers-devel >= %{version}

%description private-headers-devel
This package provides private headers of libqt5-qt3d that are normally
not used by application development and that do not have any ABI or
API guarantees. The packages that build against these have to require
the exact Qt version.

%post -n %libname -p /sbin/ldconfig

%postun -n %libname -p /sbin/ldconfig

%post -n libQt53DInput5 -p /sbin/ldconfig

%postun -n libQt53DInput5 -p /sbin/ldconfig

%post -n libQt53DQuick5 -p /sbin/ldconfig

%postun -n libQt53DQuick5 -p /sbin/ldconfig

%post -n libQt53DQuickRender5 -p /sbin/ldconfig

%postun -n libQt53DQuickRender5 -p /sbin/ldconfig

%post -n libQt53DRender5 -p /sbin/ldconfig

%postun -n libQt53DRender5 -p /sbin/ldconfig

%post -n libQt53DQuickInput5 -p /sbin/ldconfig

%postun -n libQt53DQuickInput5 -p /sbin/ldconfig

%post -n libQt53DLogic5 -p /sbin/ldconfig

%postun -n libQt53DLogic5 -p /sbin/ldconfig

%build
%if %qt5_snapshot
#force the configure script to generate the forwarding headers (it checks whether .git directory exists)
mkdir .git
%endif
%qmake5
%make_jobs

%install
%qmake5_install

# kill .la files
rm -f %{buildroot}%{_libqt5_libdir}/lib*.la

%fdupes %{buildroot}
# put all the binaries to %%_bindir and symlink them back to %%_qt5_bindir
mkdir -p %{buildroot}%{_bindir}
pushd %{buildroot}%{_libqt5_bindir}
for i in * ; do
      mv $i ../../../bin/
      ln -s ../../../bin/$i .
done
popd

%files -n %libname
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DCore.so.*

%files -n libQt53DInput5
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DInput.so.*

%files -n libQt53DQuick5
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DQuick.so.*

%files -n libQt53DQuickRender5
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DQuickRender.so.*

%files -n libQt53DRender5
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DRender.so.*
%dir %{_libqt5_libdir}/qt5/plugins/sceneparsers
%{_libqt5_libdir}/qt5/plugins/sceneparsers/libgltfsceneparser.so
%{_libqt5_libdir}/qt5/plugins/sceneparsers/libassimpsceneparser.so

%files -n libQt53DQuickInput5
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DQuickInput.so.*

%files -n libQt53DLogic5
%defattr(-,root,root,755)
%{_libqt5_libdir}/libQt53DLogic.so.*
%doc LICENSE.*

%files imports
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_archdatadir}/qml/*/

%files tools
%defattr(-,root,root,755)
%doc LICENSE.*
%{_bindir}/qgltf
%{_libqt5_bindir}/qgltf

%files examples
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_examplesdir}/

%files -n libQt53DCore-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DCore.so
%{_libqt5_libdir}/libQt53DCore.prl
%{_libqt5_libdir}/cmake/Qt53DCore/
%{_libqt5_libdir}/pkgconfig/Qt53DCore.pc
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dcore.pri
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dcore_private.pri
%{_libqt5_includedir}/Qt3DCore/
%exclude %{_libqt5_includedir}/Qt*/%{so_version}/

%files -n libQt53DInput-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DInput.so
%{_libqt5_libdir}/libQt53DInput.prl
%{_libqt5_libdir}/cmake/Qt53DInput/
%{_libqt5_libdir}/pkgconfig/Qt53DInput.pc
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dinput.pri
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dinput_private.pri
%{_libqt5_includedir}/Qt3DInput/
%exclude %{_libqt5_includedir}/Qt*/%{so_version}/

%files -n libQt53DQuick-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DQuick.so
%{_libqt5_libdir}/libQt53DQuick.prl
%{_libqt5_libdir}/cmake/Qt53DQuick/
%{_libqt5_libdir}/pkgconfig/Qt53DQuick.pc
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dquick.pri
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dquick_private.pri
%{_libqt5_includedir}/Qt3DQuick/
%exclude %{_libqt5_includedir}/Qt*/%{so_version}/

%files -n libQt53DQuickRender-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_includedir}/Qt3DQuickRender/
%{_libqt5_libdir}/cmake/Qt53DQuickRender/
%{_libqt5_libdir}/libQt53DQuickRender.so
%{_libqt5_libdir}/libQt53DQuickRender.prl
%{_libqt5_libdir}/pkgconfig/Qt53DQuickRender.pc
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dquickrender.pri
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dquickrender_private.pri
%exclude %{_libqt5_includedir}/Qt*/%{so_version}/

%files -n libQt53DQuickInput-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_includedir}/Qt3DQuickInput/
%{_libqt5_libdir}/libQt53DQuickInput.so
%{_libqt5_libdir}/libQt53DQuickInput.prl
%{_libqt5_libdir}/cmake/Qt53DQuickInput/
%{_libqt5_libdir}/pkgconfig/Qt53DQuickInput.pc
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dquickinput_private.pri
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dquickinput.pri
%exclude %{_libqt5_includedir}/Qt*/%{so_version}/

%files -n libQt53DRender-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_includedir}/Qt3DRender/
%{_libqt5_libdir}/cmake/Qt53DRender/
%{_libqt5_libdir}/libQt53DRender.so
%{_libqt5_libdir}/libQt53DRender.prl
%{_libqt5_libdir}/pkgconfig/Qt53DRender.pc
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3drender_private.pri
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3drender.pri
%exclude %{_libqt5_includedir}/Qt*/%{so_version}/

%files -n libQt53DLogic-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt53DLogic.so
%{_libqt5_libdir}/libQt53DLogic.prl
%{_libqt5_libdir}/cmake/Qt53DLogic/
%{_libqt5_libdir}/pkgconfig/Qt53DLogic.pc
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dlogic.pri
%{_libqt5_archdatadir}/mkspecs/modules/qt_lib_3dlogic_private.pri
%{_libqt5_includedir}/Qt3DLogic/
%exclude %{_libqt5_includedir}/Qt*/%{so_version}/

%files private-headers-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_includedir}/Qt*/%{so_version}/

%files devel
%defattr(-,root,root,755)
%doc LICENSE.*

%changelog
* Mon Mar  6 2017 mlin@suse.com
- Update to 5.6.2 (bsc#1028654)
  * 5.6 bugfix release http://blog.qt.io/blog/2016/10/12/qt-5-6-2-released/
- Fix baselibs.conf
* Tue Jun 14 2016 mlin@suse.com
- Update to 5.6.1 (boo#984605)
  * For more details please see:
    http://blog.qt.io/blog/2016/06/08/qt-5-6-1-released/
* Fri Apr  8 2016 alarrosa@suse.com
- Updated Qt to 5.6.0, a LTS release (fate#320330)
* Wed Mar 30 2016 alarrosa@suse.com
- Add fix-assimp-bigendian-lvalue.diff to fix a non-lvalue being
  referenced by an unary & in assimp on s390/s390x
* Fri Mar 18 2016 hrvoje.senjan@gmail.com
- Update to 5.6.0
  * For more details please see:
    http://blog.qt.io/blog/2016/03/16/qt-5-6-released/
    and https://wiki.qt.io/New_Features_in_Qt_5.6
* Wed Feb  3 2016 alarrosa@suse.com
- [ECO] Update Qt5 to version 5.5.1 (fate#319961, bnc#964864)
* Fri Oct 16 2015 hrvoje.senjan@gmail.com
- Update to 5.5.1
  * For more details please see:
    http://blog.qt.io/blog/2015/10/15/qt-5-5-1-released/
* Sat Aug 22 2015 hrvoje.senjan@gmail.com
- Activate package
